

  
    var numberOfRows; //determine the number of rows we want
    var numberOfColumns; //determine the number of columns we want

    var xStep; //determine the size of the gap between two points on the x axis
    var yStep; //determine the size of the gap between two points on the y axis

    var positions = []; //an array of positions where we will store each of our Vectors
    var trailPoints = [];

    var x = 0;
    var y = 0;

    var theAxis = 0;

    /*var xAxis = 0;
    var yAxis = 0;
    var zAxis = 0;*/


    var serial;
    var portName = '/dev/cu.usbmodem1411';
    var dataRead;
    var now = millis();
    var interval = 1000;
    var lastReadTime = 0;

    function setup(){

      serial = new p5.SerialPort(); 
    // now set a number of callback functions for SerialPort
      /*serial.on('list', printList); 
      serial.on('connected', serverConnected);
      serial.on('open', portOpen); 
      serial.on('data', serialEvent);
      serial.on('error', serialError);
      serial.on('close', portClose); 
    
      serial.list();
      serial.open(portName);*/


      numberOfColumns = 16;
      numberOfRows = 9; 

      x = 200;
      y = 200;

      createCanvas(1200,600);
      background(255);
      
      xStep = (width)/numberOfColumns;
      yStep = (height)/numberOfRows;
      
      for(var x = 0; x < width; x += xStep){
      
        for(var y = 0; y < height; y += yStep){
        
          var p = createVector(x, y);
          
          positions.push(p);
          
        }
      }
    }

    function keyPressed(){
      if(keyCode === UP_ARROW){
        theAxis = 0;
      }
      if (keyCode === DOWN_ARROW){
        theAxis = 1;
      }
      return false;
    }

    function draw(){

      stroke(70);
      strokeWeight(6);
      var trail = point(x, y);

      var dataRead = random(15);


      switch (theAxis) {
        case 0:
          x = x + (x + dataRead/20);  //(x + 4*dataRead)(xAxis/100)
          break;
        case 1:
          y = y+ (y + dataRead/20); //(y + 4*dataRead)(yAxis/100)
          break;
      }
      
      noStroke();
      fill(135, 206, 250); //pretty blue

      
      for(var i = 0; i < positions.length; i++){ //go through all our positions
        ellipse(positions[i].x, positions[i].y, 20, 20); //put a circle at each of them
      }

      trailPoints.push(trail);

      /*for (var j = 0; j<trailPoints.length;j++){
        for (var i = 0; i<positions.length; i++){
          ellipse(positions[i].x, positions[i].y, 20, 20);
          if (j != i && trailPoints[j].intersects(positions[i])){
            positions.[i].changeColor();
          }
        }
      }*/

    }


    function serverConnected()
{
    print('serverConnected');
}

function portOpen()
{
    print('portOpen');
}

function serialEvent()
{

    /*var stringRead = serial.readStringUntil('\r\n');

    if (now == lastReadTime+interval){
      if (stringRead.length >0){
        var sensorString = split(stringRead,'\t';
          if (sensorString.length>2){
            xAxis = sensorString[0];
            yAxis = sensorString[1];
            zAxis = sensorString[2];
          }
      }
      lastReadTime = now;
    }*/
  }

function serialError(err)
{
    print('serialError ' + err);
}

function portClose()
{
    print('portClose');
}


//SOME CODE PIECES FROM: the Coding train random walker, 

